{- Dieser Quellfile gehrt zu DG9EPs Lauscher-Projekt, Verwendung nur unter
 - Bercksichtigung des beiliegenden licence.txt.   (C)1989-1995, DG9EP
 -}

{$I monisys.inc}

{$IFnDEF VP}
  {$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T+,V+,X-,Y+}
{$ENDIF}

UNIT Dump;
{$R+}
{$S- wg. Thread }

INTERFACE

USES mo_def,
     dos,crt, portpas,
     fd_div,crc {$IFDEF PMVersion} ,wincrt {$ENDIF};


FUNCTION Kiss2Host ( pData:POINTER; lenData : Longint;
                      Var sHeader : STRING;
                      VAR aDaten  : t_aDaten;
                      VAR nDaten  : Longint) : BOOLEAN;
PROCEDURE DumpText (VAR hdl:TEXT;  p : Pointer; len : longint; fUseWriteLn:BOOLEAN);
PROCEDURE Dump_AX25 (VAR hdl:TEXT;  pid : BYTE; p : Pointer; len : WORD);
PROCEDURE DumpIP (VAR hdl:TEXT;  p1 : Pointer; gesamtLen : WORD);
 FUNCTION Pid2String ( pid : longint):STRING;

TYPE t_hheader = RECORD { Monitorheader ala hostmode}
          port : BYTE;
          sTo, sFm, sVia,
          sFrame, sZeit : STRING;
          fDama : BOOLEAN;
          Pid : Integer;
          resultProtocol : LongInt; { das zuoberst liegende Protokoll }
         END;
FUNCTION HostHeaderZerlegen ({Const} sHHeader : STRING;
                             VAR res : t_hheader ) : BOOLEAN;


{* Fr TCP-IP Nummern beachte man den RFC "ASSIGNED NUMBERS". Zur Zeit ist
 * dies RFC 1340 von J.Postel (July 1992). Dieser lsst die RFCs 1060, 1010,
 * 990, 960, 943, 923, 900, 870, 820, 790, 776, 770, 762, 758, 755, 750, 739,
 * 604, 503, 433, 349 veralten
 *}

CONST PID_Text   = 240 ;  {* Kein L3 Protokoll *}
      PID_NetRom = 207 ;  {* NET/ROM, TheNet(Node) *}
      PID_IP     = 204 ;  {* Internet Protocol *}
      PID_SEGMENT=   8 ;  {* ax25-Segmentation *}
      PID_ARP    = $CD ;  {* Adress Resulution Protokoll *}
      PID_FlexNet= $CE ;  {* RMNC-FlexNet Protocol ID for Interlinks *}
      PID_BC     = $bb ;  {* *}
      PID_MayBeBC= 189 ;

VAR globalResultProtocol : Longint;
CONST
    grp_NIL                 =    -1;
    grp_ax25_seg            =     9;
    grp_IP                  =     1;
      grp_ICMP              =     2;
      grp_UDP               =    12;
      grp_IP_unknownVersion =     8;
      grp_TCP               =        1 * 65536;
      grp_PPCONVERS         =$10E10;
    grp_ARP                 =    10;

    grp_NETROM              =        2 * 65536;
      grp_NODES             =     3;
      grp_NETROM_L3RTT      =     7;

    grp_BCHEAD              =     5;
    grp_BC                  =     6;

  CONST FEND = $C0;  {* KISS-Konstante: FrameEND *}
        FESC = $DB;  {* KISS-Konstante: FrameESCape *}
        TFEND= $DC;  {* KISS-Konstante: Transponiertes FrameEND *}
        TFESC= $DD;  {* KISS-Konstante: Transponiertes FrameESCape *}


{}

IMPLEMENTATION
 USES Monitor;


CONST IPID_ICMP =    1;   {/* Internet Control Message Protocol */}
      IPID_TCP  =    6;   {/* Transmission Control Protocol */}
      IPID_UDP  =   17;   {/* User Datagram Protocol */}
      IPID_RSPF =   73;   {/* Radio Shortest Path Find */}

{}

FUNCTION MLWord2HexStr (p : Pointer; offset : BYTE ) : STRING;
{ MsbLsb Word to Hex String }
BEGIN
  Incpn (p,offset-1);
  MLWord2HexStr := HexString ( Swap(Word(p^)) );
END;

FUNCTION MLWord2Str (p : Pointer; offset : BYTE ) : STRING;
BEGIN
  IncPN(p,offset-1);
  MLWord2Str := f_str ( Swap(Word(p^)) );
END;

FUNCTION WordML (p : Pointer; offset : BYTE ) : Word;
BEGIN
  IncPN (p,offset-1);
  WordML := Swap(Word(p^));
END;

FUNCTION LongML (p : Pointer; offset : BYTE ) : LongInt;
  TYPE T_c = ARRAY [1..4] OF Byte;
  VAR pc : ^T_c;
BEGIN
  IncPN (p,offset);
  pc := p;
  LongML := (pc^[1] SHR 24) OR (pc^[2] SHR 16)
         OR (pc^[3] SHR  8) OR (pc^[4]       );
END;

{}


PROCEDURE AX25Call2String (VAR p : Pointer; VAR s : String);
  VAR i,ssid : BYTE;
BEGIN
  FOR i := 1 TO 6 DO
    BEGIN
    s := s + char(byte(p^) DIV 2);
    IncP1(p);
    END;
  ssid := (Byte(p^) DIV 2) AND 15;
  IF ssid <> 0 THEN BEGIN
                    i := length(s);
                    WHILE (s[i]=' ') AND (i>0) DO Dec (i);
                    s[0] := char (i);
                    s := s + '-' +  f_Str (ssid);
                    END;
  Incp1(p);
END;


{--------------------------------------------------------------------------}


FUNCTION Kiss2Host ( pData:POINTER; lenData : Longint;
                      Var sHeader : STRING;
                      VAR aDaten  : t_aDaten;
                      VAR nDaten  : Longint) : BOOLEAN;
{* Wandelt KissFrame (Adresse in pData, Lnge in lenData) in Daten um,
 * wie sie HostMode liefern wrde (Header und Daten). Alle FEND etc.
 * muessen entfernt sein; pData^ zeigt auf das Kiss-Gerte/CRC/Byte.
 * Wenn das offenbar kein korrektes Frame ist (SMACK-CRC, Ax25-Logik), wird
 * false zurckgegeben.
 *}
  Type T_Cast = Array [1..500] OF BYTE;
  Var kissbuf : ^T_Cast;  {* q&d *}
      i,j : WORD;
      ctl,
      nSSID : BYTE;
      sTyp : STRING;
      fCommand,
      fDama,
      fSmack : BOOLEAN; { 0 0 b 92 76 65 c0  0 71 88 72 94 9c 40 61 d1 0 0}
                        { 0 0 b 92 76 65 db dc 00 11 }
BEGIN
  Kiss2Host := FALSE;
  kissbuf := pData;
  sHeader := 'fm ';
  nDaten := 0;

  fSmack := kissBuf^[1] = $80;
  IF NOT fSmack AND (kissBuf^[1] <> 0) THEN Exit;  {* Untersttzung nur fr einen Port und SMACK *}

  IF (kissbuf^[6] AND 1)=1
    THEN BEGIN {flexnet-header-kompress}
         sHeader := 'fm flxcom to test ctl ... pid ... ';
         j := 1;
         END
    ELSE BEGIN
         FOR i := 9 TO 14 DO sHeader := sHeader + char(byte(kissBuf^[i]) div 2);
         RTrim(sHeader);
         nssid := (byte(KissBuf^[15]) div 2) AND 15;
         IF nssid<>0 THEN sHeader := sHeader + '-'+f_str(nssid);
         fDama := (byte(KissBuf^[15]) AND $60) = $40;

         sHeader := sHeader + ' to ';
         FOR i := 2 TO 7 DO sHeader := sHeader + char(byte(kissBuf^[i]) div 2);
         RTrim(sHeader);
         nssid := (byte(KissBuf^[8]) div 2) AND 15;
         IF nssid<>0 THEN AddString(sHeader, '-'+f_str(nssid) );

         j := 15;
         WHILE ((Byte(kissbuf^[j]) and 1) = 0) AND (j<=lenData) DO
           BEGIN
           IF j=15 THEN  AddString(sHeader, ' via ')
                   ELSE  AddString(sHeader, ',');
           J := j+1;
           FOR i := j TO j+5 DO
              AddString(sHeader, char(byte(kissBuf^[i]) DIV 2) );
           RTrim(sHeader);
           nssid := (byte(KissBuf^[j+6]) div 2) AND 15;
           IF nssid<>0 THEN sHeader := sHeader + '-'+f_str(nssid);
           j := j+6;
           END;

         IF j MOD 7 <> 1 THEN  Exit;

         Inc(j);
         ctl := byte(KissBuf^[j]);
         sTyp := '';
         IF ctl and $0f =   1 THEN sTyp := 'RR'   ELSE
         IF ctl and $01 =   0 THEN sTyp := 'I'    ELSE
         IF ctl and $0f =   5 THEN sTyp := 'RNR'  ELSE
         IF ctl and $0f =   9 THEN sTyp := 'REJ'  ELSE
         IF ctl and $ef = $63 THEN sTyp := 'UA'   ELSE
         IF ctl and $ef = $2f THEN sTyp := 'SABM' ELSE
         IF ctl and $ef = $43 THEN sTyp := 'DISC' ELSE
         IF ctl and $ef = $0f THEN sTyp := 'DM'   ELSE
         IF ctl and $ef = $03 THEN sTyp := 'UI'   ELSE
         IF ctl and $ef = $87 THEN sTyp := 'FRMR';

         AddString(sHeader, ' ctl '+sTyp );
         IF (sTyp = 'I') THEN
           BEGIN {* Tx/Rx-Folgennr. *}
           AddString(sHeader, f_str( ((ctl AND $E0) SHR 5) )
                            + f_str( ((ctl AND $0e) SHR 1) ) );
           END;
         IF (ctl AND $0f) in [1,5,9] THEN
           BEGIN
           AddString(sHeader, f_str(((ctl AND $E0 ) SHR 5)) );
           END;

{        sHeader := sHeader
                    + ' '+ HexByteString( byte(KissBuf^[8]) AND $e0 )
                    + ' '+ HexByteString( byte(KissBuf^[15]) AND $e0 );
}
         fCommand :=  ((byte(KissBuf^[8]) AND $80)<>0) AND ((byte(KissBuf^[15]) AND $80)=0);
         IF ((byte(KissBuf^[8])  AND $80)=0) AND ((byte(KissBuf^[15]) AND $80)=0)
            THEN AddString(sHeader,' V1')
            ELSE BEGIN {version2}
                 IF ctl and $10 <> 0 { P/F ? }
                   THEN IF fCommand THEN sHeader := sHeader + '+'
                                    ELSE sHeader := sHeader + '-'
                   ELSE IF fCommand THEN sHeader := sHeader + 'v'
                                    ELSE sHeader := sHeader + '^'
                 END;

         IF (sTyp = 'I') OR (sTyp = 'UI') THEN
           BEGIN
           Inc(j);
           sHeader := sHeader
                    + ' pid '
                    + HexByteString(byte(KissBuf^[j])) + ' ';
           END;
         Inc(j);

         IF fDama  THEN AddString(sHeader,' [DAMA]');
         {IF fSmack THEN AddString(sHeader,' [SMACK]');}

         {*
          * sHEader :=sHeader + f_str( (byte(KissBuf^[ 8]) AND $60) SHR 5 );
          * sHEader :=sHeader + f_str( (byte(KissBuf^[15]) AND $60) SHR 5 );
          *}
         nDaten := lenData+1-j;
         END;
  {* Uhrzeit in der Form ' - 29.12.94 12:23:34' *}
  AddString(sHeader, ' - '+CurrentDatum+' '+CurrentUhrzeit(0) );
  sAddStatusInfo := '';
  IF fSmack THEN
    BEGIN
    Dec(nDaten,2); {PrfBytes raustuen}
    sAddStatusInfo := '[SMACK]';
    END;
  IF nDaten<0 THEN nDaten := 0;
  Move (kissbuf^[j], aDaten[1], nDaten);

  IF fSmack THEN Kiss2Host := Calc_CRC16( 0, pData, lenData)=0
            ELSE Kiss2Host := TRUE;
END;




FUNCTION HostHeaderZerlegen ({Const} sHHeader : STRING;
                             VAR res : t_hheader ) : BOOLEAN;
  VAR iTo, iVia, iCtl, iPid, iZeit, iToEnd : WORD;
      s : STRING;
      nDama : WORD;
BEGIN
HostHeaderZerlegen := FALSE;
FillChar(res,sizeof(res),#0);
WITH res DO
  BEGIN
  resultProtocol := grp_NIL;

  {* DRSI-artige Portangabe entfernen, falls vorhanden *}
  port := 1; {* Default *}
  IF sHHeader[2]=':' THEN
    BEGIN
    IF (sHHEader[1]>='0') AND (sHHEader[1]<='9') THEN port := Ord(sHHEader[1])-Ord('0');
    Delete (sHHeader,1,2)
    END;

  nDama := Pos('[DAMA]',sHHeader);
  fDama := nDAma > 0;
  IF fDama THEN Delete(sHHeader,nDama,6);

  iTo  := Pos(' to ',sHHeader);
  iVia := Pos(' via ',sHHeader);
  iCtl := Pos(' ctl ',sHHeader);
  iPid := Pos(' pid ',sHHeader);
  iZeit:= Pos(' - ',sHHeader)+3;

  IF iVia = 0 THEN iToEnd := iCtl
              ELSE iToEnd := iVia;
  IF iTo < 4 THEN Exit;

  sFm := Copy(sHHeader, 4, iTo - 4 );
  sTo := Copy(sHHeader, iTo + 4, iToEnd-iTo - 4);
  RTrimCtrl(sFm); {* VP hat da wohl manchmal Schwierigkeiten *}
  RTrimCtrl(sTo); {* VP hat da wohl manchmal Schwierigkeiten *}

{$Q-}
  IF iCtl = iToEnd
    THEN sVia := ''
    ELSE sVia:= Copy(sHHeader, iToEnd + 5, iCtl - iToEnd - 5);
  pid := -1;
  IF iPid > 0
    THEN BEGIN
         s := Copy(sHHeader, iPid+5, 2);
         Pid := 16*SNibble2Byte(s[1])+SNibble2Byte(s[2]);
         sFrame := Copy(sHHeader, iCtl+5, iPid-iCtl-5);
         END
    ELSE BEGIN  {- keine Pid, also RR & Co, -}
         IF iZeit>3 THEN sFrame := Copy(sHHeader, iCtl+5, iZeit-iCtl-8)
                    ELSE sFrame := Copy(sHHeader, iCtl+5, 255);
         END;
  IF iZeit > 3 THEN sZeit := Copy(sHHeader, iZeit, 255)
               ELSE sZeit := '';
  IF fDama THEN AddChar(sFrame,'D');
{$R+}
  {--------------------------------------------------}
  {* Umwandlung fr Broadcast Sendungnen mit PID F0 *}
  IF PID=$F0 THEN
   IF sTo = 'QST-1' THEN
    IF Copy(sFrame,1,2) = 'UI' THEN
      BEGIN
      Pid := $bb;
      sFrame := sFrame + '-pidConv';
      END;
  END;
HostHeaderZerlegen := TRUE;
END;


{}

PROCEDURE DumpHex (VAR hdl:TEXT;  p : Pointer; len : Longint);
  VAR i,orgTextAttr : WORD;
      sAscii : STRING;
BEGIN
  orgTextAttr := TextAttr;
  Flush(hdl);
  SetTextAttr (FARBE_DUMP_HEX);
  sAscii := '';

  FOR i := 1 TO len do
    BEGIN
    Write (hdl,HexByteString(BYTE (p^)),' ');
    IF byte(p^) >= 32 THEN sAscii := sAscii+char(p^)
                      ELSE sAscii := sAscii+'.';
    IF i MOD 16 = 0
      THEN BEGIN
           Writeln(hdl,'  ',sAscii);
           sAscii := '';
           END
      ELSE IF i MOD 8 = 0 THEN
             BEGIN
             sAscii := sAscii+' ';
             Write (hdl,'  ');
             END;

    Incp1(p);
    END;
  WriteLn(hdl,'  ',sAscii);
  Flush(hdl);
  TextAttr := orgTextAttr;
END;


PROCEDURE DumpText (VAR hdl:TEXT;  p : Pointer; len : longint; fUseWriteLn:BOOLEAN);
  VAR i : WORD;
      CRflag : BOOLEAN;
      orgTextAttr : BYTE;
BEGIN
  IF len<=0 THEN Exit;
  orgTextAttr := TextAttr;
  IF len > 1200 THEN
    BEGIN
    WriteLn(hdl);
    WriteLn (hdl,' <zu Iang>: ',len);
    Exit;
    END;
  CRFlag := FALSE;
  FOR i := 1 TO len do
    BEGIN
    CASE char (p^) OF
      CR : BEGIN
           Flush(hdl);
           SetTextAttr (FARBE_TEXT_CTRLCHAR);
           Write (hdl,'');
           IF WhereX <> 1 THEN CRFLAG := TRUE;
           END;
      ^J : BEGIN
           Flush(hdl);
           SetTextAttr (FARBE_TEXT_CTRLCHAR);
           Write (hdl,'J');
           CRflag := TRUE;
           END;
      #255
         : BEGIN
           Flush(hdl);
           SetTextAttr (FARBE_TEXT_CTRLCHAR);
           Write (hdl,'-');
           END;
      ELSE BEGIN
           IF char(p^)<#32
             THEN  BEGIN
                   Flush(hdl);
                   SetTextAttr (FARBE_TEXT_CTRLCHAR);
                   Write (hdl, char(byte(p^)+64));
                   IF CRFLAG AND fUseWriteLn THEN WriteLn(hdl);
                   CRflag := FALSE;
                   END
              ELSE BEGIN
                   IF CRFLAG AND fUseWriteLn THEN WriteLn(hdl);
                   CRflag := FALSE;
                   Flush(hdl);
                   TextAttr := orgTextAttr;
                   Write (hdl,char (p^));
                   END;
           END;
      END;
    IncP1(p);
    END;
  Flush(hdl);
  TextAttr := orgTextAttr;
END;


{--------------------------------------------------------------------------}

FUNCTION TcpPort2Str(portnr:word) : STRING;
BEGIN
    CASE portnr OF
        20  : TcpPort2Str := 'FTP-DATA';
        21  : TcpPort2Str := 'FTP-CMD';
        23  : TcpPort2Str := 'TelNet';
        25  : TcpPort2Str := 'SMTP';
        53  : TcpPort2Str := 'Domain Name Server';
        79  : TcpPort2Str := 'Finger';
        80  : TcpPort2Str := 'WWW';
       107  : TcpPort2Str := 'RemoteTelNet';
       109  : TcpPort2Str := 'Pop2';
       110  : TcpPort2Str := 'Pop3';
       119  : TcpPort2Str := 'NNTP';
       161  : TcpPort2Str := 'SNMP';
       3600 : TcpPort2Str := 'ppConvers';
       3610 : TcpPort2Str := 'conversD';
       3612 : TcpPort2Str := 'ConversD';
       6667 : TcpPort2Str := 'IRC';
       6810 : TcpPort2Str := 'ConversD';
       ELSE{case}TcpPort2Str := '';
     END;
END;

PROCEDURE WriteIncPas(VAR hdl:TEXT; VAR p : Pointer);
BEGIN
  Write(hdl, string(p^));
  p := Incp(p,byte(p^)+1);
END;



PROCEDURE DumpDNSName (VAR hdl:TEXT; pBase:Pointer; VAR p1 : POINTER);
BEGIN
   IF Byte(p1^) < $c0
        THEN BEGIN
             WHILE Byte(p1^) in [1..63] DO
               BEGIN
               WriteIncPas(hdl, Pointer(p1));
               Write(hdl,'.');
               END;
             {p1 zeigt jetzt auf die Term\0}
             Incp1(p1);
             END
        ELSE BEGIN
             IncPN(pBase, swap(word(p1^)) AND $3fff);
             IF Byte(pBase^) < $c0 THEN DumpDNSName (hdl, nil, pBase);
             Incpn(p1,2);
             END;
END;

PROCEDURE DumpDomainNameServer (VAR hdl:TEXT; p1 : POINTER; dlen : WORD);
  TYPE T_DNS = PACKED RECORD
                 id, parameter{flags},
                 nQuest, nAnswers,
                 nAuth,  nAdd : WORD;
                 data : Byte;
               END;
       T_tc = PACKED RECORD
                typ,
                qclass : WORD
              END;

  VAR pdns : ^T_dns;
      rDataLen,
      i :WORD;
{      s : STRING;}
      pz : POINTER;
      typ : WORD;
BEGIN
  pdns := Pointer(p1);
  WITH pdns^ DO
    BEGIN
    Write(hdl, 'DNS Id:', swap(id),' - '

               );
    Write  (Hdl, ' opcode=',swap(Parameter) AND $78,
                  ' rc=' ,swap(Parameter) AND $0F);
    IF swap(Parameter) AND $8000 <> 0 THEN Write(Hdl, ' response ' )
                                      ELSE Write(Hdl, ' query ');
    IF swap(Parameter) AND   $80 <> 0 THEN Write(Hdl, ' recurs.desir.' );
    IF swap(Parameter) AND  $100 <> 0 THEN Write(Hdl, ' recurs.avail.' );
    IF swap(Parameter) AND  $200 <> 0 THEN Write(Hdl, ' Autho.' );
    IF swap(Parameter) AND  $400 <> 0 THEN Write(Hdl, ' Trunc.' );
    WriteLn(hdl);
    WriteLn(hdl,
                 swap(nQuest),' Frage(n), ',
                 swap(nAnswers),' RR-Antworte(n), ',
                 swap(nAuth),' AuthRR, ',
                 swap(nAdd),' AddRR '
    );


    p1:= IncP(p1,sizeof(T_DNS)-1);
    FOR i := 1 TO swap(nQuest) DO
      BEGIN
      Write(hdl,'-Question: ');
      DumpDNSName (hdl, pDNS, p1);
      WriteLn(hdl, ' -  qtyp=',  swap(t_tc(p1^).typ),
                    ' qclass=',swap(t_tc(p1^).qclass)
      );
      IncPN(p1,4);
      END;

    FOR i := 1 TO swap(nAnswers)+swap(nAuth)+swap(nAdd) DO
      BEGIN
      Write(hdl,'-AnswerRR: ');
      DumpDNSName (hdl, pDNS, p1);
      typ := swap(t_tc(p1^).typ);
      Write(hdl, ' -  qtyp=', typ,
                   ' qclass=',swap(t_tc(p1^).qclass)
      );
      Incpn(p1,4);

      CASE typ OF
          1 : Write(hdl,'  IP-Adresse: ');
          2 : Write(hdl,'  Namserver: ');
          5 : Write(hdl,'  Alias: ');
      END;

{      Write(hdl, ' -  ttl=',  longint(p1^), '  ' ); }
      IncPN(p1,4);

      rdatalen := swap(word(p1^));
      IncPN(p1,2);
      pz := p1;
      CASE typ OF
          1 : WriteLn(hdl,byte(p1^),'...');
          2,5 : BEGIN
              DumpDNSName (hdl, pDNS, pz);
              Writeln(hdl);
              END;
          ELSE  DumpHex(hdl, p1, rDatalen);
          END;
      IncPN(p1, rDatalen);
      END;

    END;
END;



PROCEDURE DumpUDP (VAR hdl:TEXT; p1 : Pointer; dlen : WORD);
  TYPE T_UDP = PACKED RECORD sourceportHL,
                      destportHL,
                      lenHL,
                      crcHL : WORD;
                      data : BYte
                      END;
  VAR p : tp_by1Array;
      pudp : ^T_UDP;
BEGIN
  globalResultProtocol := grp_UDP;
  p := p1;
  pudp := p1;
  WITH pUDP^ DO
    BEGIN
    WriteLn(hdl, 'Ports:', Swap(sourcePortHL), '', Swap(destPortHL),
                 ' Len:', Swap(lenHL));
    IF (swap(sourcePortHL)=21) OR (swap(destportHL)=21)
    THEN BEGIN
         Write(hdl, 'FSP' );
         Flush(hdl);
         SetTextAttr (FARBE_OTHER_TEXTDATA);
         DumpText (hdl, @data, dlen-(sizeof(t_udp)-1) , false);
         END
    ELSE IF (swap(sourcePortHL)=53) OR (swap(destportHL)=53)
      THEN DumpDomainNameServer(hdl,@data,dlen-(sizeof(t_udp)-1) )
      ELSE DumpHex (hdl,@data,dlen-(sizeof(t_udp)-1) );
    END
END;


PROCEDURE DumpICMP (VAR hdl:TEXT; p1 : Pointer; dlen : WORD);
  VAR p : tp_by1Array;
      typ : BYTE;
      i : WORD;
  Procedure WriteDroppedDatagramm;
  BEGIN
    WriteLn(hdl, ', dropped datagram was (part):');   {* Source Quench *}
    DumpIP (hdl,@p^[9],dlen-8);
  END;
BEGIN
  globalResultProtocol := grp_ICMP;
  p := p1;
  typ := p^[1];
  CASE typ OF  {* Message Typ *}
     0,8 : BEGIN
           IF typ = 8 THEN Write(hdl, 'Echo request (ping)')
                      ELSE Write(hdl, 'Echo Reply (ping-reply)');

           Write(hdl, ' id:' + MLWord2HexStr (p,5));
           Write(hdl, ' seq:'+ MLWord2HexStr (p,7));
           Flush(hdl);
           SetTextAttr (FARBE_OTHER_TEXTDATA);
           WriteLn(hdl);
           DumpHex (hdl,@p^[9],dlen-8);
           END;

     3 : BEGIN
         CASE p^[2] of
             0 : Write(hdl, 'Network unreachable');
             1 : Write(hdl, 'Host unreachable');
             2 : Write(hdl, 'Protocol unreachable');
             3 : Write(hdl, 'Port unreachable');
             4 : Write(hdl, 'Fragm.needed but DF set');
             5 : Write(hdl, 'Source route failed');
             6 : Write(hdl, 'Dest.Network unknown');
             7 : Write(hdl, 'Dest.Host unknown');
             8 : Write(hdl, 'Source Host isolated');
             ELSE Write(hdl, '[other:',HexByteString (p^[2]) );
           END;
         WriteDroppedDatagramm;
         END;
     4 : BEGIN
         Write(hdl, ' Source-Quench');                  {* Source Quench *}
         WriteDroppedDatagramm;
         END;
     5 : Write(hdl, 'Redirect');                {* Redirect *}
    11 : Write(hdl, 'Time Exceed');             {* Time-to-live Exceeded *}
    12 : Write(hdl, 'Param Prob');              {* Parameter Problem *}
    13 : Write(hdl, 'Timestamp');               {* Timestamp *}
    14 : Write(hdl, 'Time Reply');              {* Timestamp Reply *}
    15 : Write(hdl, 'Info Request');            {* Information Request (obsolete)*}
    16 : Write(hdl, 'Info Reply');              {* Information Reply (obsolete)*}
    17 : Write(hdl, 'Adress Mask Request');
    18 : Write(hdl, 'Adress Mask Reply');
    ELSE BEGIN
         Write(hdl, '-Unknown type-0x0' + HexByteString (p^[21]));
         Write(hdl, ' Code:'+HexByteString (p^[2]));
         Write(hdl, ' chksum:' + MLWord2Str (p,3));
         END;
    END;
END;


PROCEDURE DumpRSPF (VAR hdl:TEXT; p1 : Pointer; dlen : WORD);
  VAR i : WORD;
      p : Pointer;
BEGIN
  WriteLn(hdl); p := p1;
  FOR i := 1 TO dlen DO
    BEGIN
    IF byte (p1^) = 44 THEN WriteLn(hdl);
    Write (hdl,byte (p1^):4);
    IncP1(p1);
    END;
  Flush(hdl);
  SetTextAttr (FARBE_OTHER_TEXTDATA);
  WriteLn(hdl);
  DumpText (hdl , p, dLen, true );  {* Damit das RouterHello auch zu sehen ist *}
END;



PROCEDURE DumpTCP (VAR hdl:TEXT; p1 : Pointer; lenAll : Longint);
  VAR p : tp_by1Array;
      lenTcpHead : Longint;
      port1,port2, relport,
      wor{,i} : WORD;
      sTemp,sErg,sPrint,
      sPort : STRING;
      flags : BYTE;
      hdlNNTP : FILE;
Label      l_Skip;
BEGIN
  globalResultProtocol := grp_TCP;
  p := p1;
  port1 := Swap(Word(p1^) );
  port2 := WordML (p,3);
  lenTcpHead := (p^[13] SHR 4)*4;
  flags := p^[14];

  IF NOT opt.fTCPIPHeader THEN GOTO l_skip;

  Write (hdl, 'Ports:', port1,'', port2);
  IF (lenAll<20) OR (lenTcPHead<20) THEN
    BEGIN
    WriteLn(hdl,' (Kopf ist nicht komplett)');
    DumpHex(hdl, p1, lenAll);
    Exit;
    END;

  IF lenTcpHead <> 20 THEN Write(hdl,' TcpLen:', lenTcpHead);

  Write (hdl,' seq:');
  FOR wor := 5 to 8 DO  Write (hdl,HexByteString (p^[wor]) ); {*Sequenznr.*}

  IF flags AND 16 = 16 THEN
    BEGIN {* Ack-Field is Valid. see also: Commer I, p.184 *}
    Write (hdl,' ack:' );
    FOR wor := 9 to 12 DO Write (hdl, HexByteString ( p^[wor] )); {*Ack.Nr.*}
    END;

  IF flags AND  1 =  1 THEN Write (hdl,' FIN');
  IF flags AND  2 =  2 THEN Write (hdl,' SYN');
  IF flags AND  4 =  4 THEN Write (hdl,' RST');
  IF flags AND  8 =  8 THEN Write (hdl,' PSH');

  Write (hdl, ' Wind.:', MLWord2HexStr (p,15));
  IF flags AND 32 = 32 THEN Write (hdl,' Urg.P.:', MLWord2HexStr (p,39) );
l_skip:
  IF lenTcpHead > 20 THEN
    BEGIN
    Writeln(hdl);
    Write(hdl, 'Options');
    DumpHex (hdl,  @p^[21], lenTcpHead-20);
    {n:=21; while p[n]<>0 do (if p[n]=2 then mtu:=p[n+1],inc(n,2);) }
    IF lenAll<=lenTcpHead THEN Exit;
    END;


  IncPN( p1, lenTcpHead );
  IF lenAll<>lenTcpHead THEN {*es sind noch daten dran, ansonsten nur pures Protokoll *}
    BEGIN
    globalResultProtocol := grp_TCP+port1;
    relPort := port1;
    sPort := TcpPort2Str(port1);
    IF sPort='' THEN
      BEGIN
      sPort := TcpPort2Str(port2);
      relport := port2;
      END;
    WriteLn(hdl);
    IF sPort <> '' THEN Write(hdl,'',sPort,'');
    CASE relport OF
 {$IFDEF sdfsdfsdfsdf} s,dfsfhs
      19 : BEGIN
           Assign(hdlNNTP,'nntp.doc');                {$i-}
           Reset(hdlNNTP,1);
           IF IOResult <> 0 THEN
             BEGIN {* aha! neuer File ... *}
             Rewrite(hdlNNTP,1);
             END;
           BlockWrite(hdlNNTP, p1^, lenAll-lenTcpHead);
           Close(hdlNNTP);
           END;
   {$ENDIF}
      3600,3610,3612,6810
        : BEGIN {conversd}
          sTemp[0] := char( Min(255,lenAll-lenTcpHead) );
          Move( p1^, sTemp[1], byte(sTemp[0]) );

          IF Copy(sTemp,1,7) = '/'#255#128'CMSG'
            THEN BEGIN
                 sTemp := Copy(sTemp,8,255);
                 ScanForText ( sTemp, sErg );
                 ScanForText ( sTemp, sPrint );
                 Write(hdl,'<',sPrint,':',sErg,'> ');
                 Flush(hdl);
                 SetTextAttr (FARBE_OTHER_TEXTDATA);
                 Write(hdl, sTemp);
                 END
            ELSE BEGIN
                 Flush(hdl);
                 SetTextAttr (FARBE_OTHER_TEXTDATA);
                 DumpText (hdl, p1, lenAll-lenTcpHead,true);
                 END;
          END;
      ELSE BEGIN {case}
           Flush(hdl);
           SetTextAttr (FARBE_OTHER_TEXTDATA);
           DumpText (hdl, p1, lenAll-lenTcpHead, true);
           END;
      END;{case}
    END;
END;

PROCEDURE DumpPIDSegment (VAR hdl:TEXT;  p1 : Pointer; gesamtLen : WORD); forward;

PROCEDURE DumpIP (VAR hdl:TEXT;  p1 : Pointer; gesamtLen : WORD);
{* siehe RFC 791 *}
  VAR wor,
      totIpLen,
      fOffSet,
      headerLen : WORD;
      p         : ^by1Array;
      ipVers,
      protocol : BYTE;
      fMore    : BOOLEAN;
      sProtokoll : STRING;
label l,l_Skip;
BEGIN
  globalResultProtocol := grp_IP;
  p := p1;
  Flush(hdl);
  SetTextAttr (FARBE_HEADER_IP);
  Write (hdl,'IP');
l:
  ipvers := p^[1] SHR 4;

  IF ipVers <> 4 THEN
    BEGIN
    globalResultProtocol := grp_IP_unknownVersion;
{    Writeln(hdl,'Version ',ipVers, ' (don''t know, but let''s guess:)');
    SetTextAttr (_White_Black);}
    {* tja, irgendwie nicht normgerecht, aber wohl tatsache: *}
{    DumpPIDSegment (hdl, p1, gesamtLen ); } {*Rekursionsgefahr!*}
    Exit;
    END;

  totIpLen  := WordML (p,3); {* TOTAL LENGTH: Header+Data gesamtes Datagramm *}
  headerLen := (p^[1] AND 15) * 4; {* HEADER LENGTH in 32 Bit-words *}
  fMore     := (WordML(p,7) AND $2000 <> 0 );
  fOffset   := (WordML(p,7) AND $1fff) * 8; {* Fragment Offset in Bytes *}
  protocol  := p^[10];

  IF NOT opt.fTCPIPHeader THEN GOTO L_Skip;

  Write (hdl,'[');
  FOR wor := 13 to 15 DO  Write (hdl,p^[wor],'.' );
  Write (hdl, p^[16], '][');
  FOR wor := 17 to 19 DO  Write (hdl,p^[wor],'.' );
  Write (hdl,p^[20],']',

             ' totLen:', totIpLen,
             ' ttl:', p^[9] );
  IF (WordML(p,7) AND $4000 <>0 ) THEN Write (hdl,' DF');

  IF headerLen>20 THEN {* Ip Options sind vorhanden *}
    BEGIN
    Write (hdl,' HeaderLen:',headerlen
              ,' opt:$');
    DumpHex(hdl, IncP(p,20), headerlen-20 );
    END;

  IF gesamtLen<totIpLen THEN Write(hdl,' [SPLIT]');
  IF fMore THEN Write (hdl,' MF');

  IF p^[2] <> 0 THEN
    BEGIN {- Services -}
    Write (hdl,' Prio:', (p^[2] SHR 5)  );
    IF (p^[2] and 8) <> 0 THEN Write(hdl,' minDelay');
    IF (p^[2] and 4) <> 0 THEN Write(hdl,' maxThroghput');
    IF (p^[2] and 2) <> 0 THEN Write(hdl,' maxReliability');
    IF (p^[2] and 1) <> 0 THEN Write(hdl,' minMonetary cost');
    END;

  WriteLn(hdl);
  IF fMore THEN
     WriteLn(hdl,'Fragid/off: ',MLWord2HexStr(p,5),'/',fOffset);

L_Skip:
  CASE protocol OF
     IPID_ICMP :  sProtokoll := 'ICMP';   {/* Internet Control Message Protocol *}
     IPID_TCP  :  sProtokoll := 'TCP';   {/* Transmission Control Protocol *}
     IPID_UDP  :  sProtokoll := 'UDP';   {/* User Datagram Protocol *}
     IPID_RSPF :  sProtokoll := 'RSPF';   {/* Radio Shortest Path First *}
     63        :  sProtokoll := 'LAN';
     ELSE         sProtokoll := '<'+f_str(protocol)+'>';
   END;
  Write (hdl,sProtokoll);
  IncPN(p1,headerLen);
  IF fMore AND (fOffset<>0)
    THEN BEGIN
         Flush(hdl);
         SetTextAttr (FARBE_OTHER_TEXTDATA);
         DumpText(hdl, p1, Min(gesamtlen-headerlen,gesamtlen-Headerlen),true)
         END
    ELSE CASE protocol OF                 {bei Fragmenten wirds kompliziert}
          IPID_TCP  : DumpTCP (hdl, p1, Min(totIpLen-Headerlen,gesamtlen-Headerlen));
          IPID_RSPF : DumpRSPF(hdl, p1, Min(totIpLen-Headerlen,gesamtlen-Headerlen));
          IPID_ICMP : DumpICMP(hdl, p1, Min(totIpLen-Headerlen,gesamtlen-Headerlen));
          IPID_UDP  : DumpUDP (hdl, p1, Min(totIpLen-Headerlen,gesamtlen-Headerlen));
          ELSE        DumpText(hdl, p1, Min(gesamtlen-headerlen,gesamtlen-Headerlen),false);
          END; {CASE}
END;


PROCEDURE DumpPIDSegment (VAR hdl:TEXT;  p1 : Pointer; gesamtLen : WORD);
  Type t_c = PACKED record b1,b2:BYTE;END;
  VAR seg,pid : byte;
BEGIN
  globalResultProtocol := grp_ax25_seg;
  Flush(hdl);
  SetTextAttr (FARBE_HEADER_AXSEGM);
  Write(hdl,'AX25-Segment ');
  seg := t_C(p1^).b1;
  IF (seg and $80) <> 0
    THEN BEGIN
         WriteLn(hdl,'First segment; ',seg and $7f,' remaining segments');
         pid := t_C(p1^).b2;
         Flush(hdl);
         SetTextAttr (FARBE_OTHER_TEXTDATA);
         Dump_AX25 (hdl, pid, IncP(p1,2), gesamtLen-2);
         END
    ELSE BEGIN
         Writeln(hdl,seg and $7f,' remaining segments');
         Flush(hdl);
         SetTextAttr (FARBE_OTHER_TEXTDATA);
         DumpText (hdl, IncP(p1,1), gesamtLen-1, true);
         END;
END;

  {               ----- Type-of-Service Value -----
      Protocol           TOS Value
      --------------------------------------------------------
      TELNET (1)         1000                 (minimize delay)
      FTP
        Control          1000                 (minimize delay)
        Data (2)         0100                 (maximize throughput)
      TFTP               1000                 (minimize delay)
      SMTP (3)
        Command phase    1000                 (minimize delay)
        DATA phase       0100                 (maximize throughput)
      Domain Name Service
        UDP Query        1000                 (minimize delay)
        TCP Query        0000
        Zone Transfer    0100                 (maximize throughput)
      NNTP               0001                 (minimize monetary cost)
      ICMP
        Errors           0000
        Requests         0000 (4)
        Responses        <same as request> (4)
      Any IGP            0010                 (maximize reliability)
      EGP                0000
      SNMP               0010                 (maximize reliability)
      BOOTP              0000
}


 { Assigned Internet Protocol Numbers
      Decimal    Keyword     Protocol                         References
      -------    -------     --------                         ----------
           0                 Reserved                              [JBP]
           1     ICMP        Internet Control Message           [97,JBP]
           2     IGMP        Internet Group Management          [43,JBP]
           3     GGP         Gateway-to-Gateway                  [60,MB]
           4     IP          IP in IP (encasulation)               [JBP]
           5     ST          Stream                             [49,JWF]
           6     TCP         Transmission Control              [106,JBP]
           7     UCL         UCL                                    [PK]
           8     EGP         Exterior Gateway Protocol        [123,DLM1]
           9     IGP         any private interior gateway          [JBP]
          10     BBN-RCC-MON BBN RCC Monitoring                    [SGC]
          11     NVP-II      Network Voice Protocol             [22,SC3]
          12     PUP         PUP                               [8,XEROX]
          13     ARGUS       ARGUS                                [RWS4]
          14     EMCON       EMCON                                 [BN7]
          15     XNET        Cross Net Debugger                [56,JFH2]
          16     CHAOS       Chaos                                 [NC3]
          17     UDP         User Datagram                     [104,JBP]
          18     MUX         Multiplexing                       [23,JBP]
          19     DCN-MEAS    DCN Measurement Subsystems           [DLM1]
          20     HMP         Host Monitoring                    [59,RH6]
          21     PRM         Packet Radio Measurement              [ZSU]
          22     XNS-IDP     XEROX NS IDP                    [133,XEROX]
          23     TRUNK-1     Trunk-1                              [BWB6]
          24     TRUNK-2     Trunk-2                              [BWB6]
          25     LEAF-1      Leaf-1                               [BWB6]
          26     LEAF-2      Leaf-2                               [BWB6]
          27     RDP         Reliable Data Protocol            [138,RH6]
          28     IRTP        Internet Reliable Transaction      [79,TXM]
          29     ISO-TP4     ISO Transport Protocol Class 4    [63,RC77]
          30     NETBLT      Bulk Data Transfer Protocol       [20,DDC1]
          31     MFE-NSP     MFE Network Services Protocol    [124,BCH2]
          32     MERIT-INP   MERIT Internodal Protocol             [HWB]
          33     SEP         Sequential Exchange Protocol        [JC120]
          34     3PC         Third Party Connect Protocol         [SAF3]
          35     IDPR        Inter-Domain Policy Routing Protocol [MXS1]
          36     XTP         XTP                                   [GXC]
          37     DDP         Datagram Delivery Protocol            [WXC]
          38     IDPR-CMTP   IDPR Control Message Transport Proto [MXS1]
          39     TP++        TP++ Transport Protocol               [DXF]
          40     IL          IL Transport Protocol                [DXP2]
       41-60                 Unassigned                            [JBP]
          61                 any host internal protocol            [JBP]
          62     CFTP        CFTP                              [50,HCF2]
          63                 any local network                     [JBP]
          64     SAT-EXPAK   SATNET and Backroom EXPAK             [SHB]
          65     KRYPTOLAN   Kryptolan                            [PXL1]
          66     RVD         MIT Remote Virtual Disk Protocol      [MBG]
          67     IPPC        Internet Pluribus Packet Core         [SHB]
          68                 any distributed file system           [JBP]
          69     SAT-MON     SATNET Monitoring                     [SHB]
          70     VISA        VISA Protocol                        [GXT1]
          71     IPCV        Internet Packet Core Utility          [SHB]
          72     CPNX        Computer Protocol Network Executive  [DXM2]
          73     CPHB        Computer Protocol Heart Beat         [DXM2]
          74     WSN         Wang Span Network                     [VXD]
          75     PVP         Packet Video Protocol                 [SC3]
          76     BR-SAT-MON  Backroom SATNET Monitoring            [SHB]
          77     SUN-ND      SUN ND PROTOCOL-Temporary             [WM3]
          78     WB-MON      WIDEBAND Monitoring                   [SHB]
          79     WB-EXPAK    WIDEBAND EXPAK                        [SHB]
          80     ISO-IP      ISO Internet Protocol                 [MTR]
          81     VMTP        VMTP                                 [DRC3]
          82     SECURE-VMTP SECURE-VMTP                          [DRC3]
          83     VINES       VINES                                 [BXH]
          84     TTP         TTP                                   [JXS]
          85     NSFNET-IGP  NSFNET-IGP                            [HWB]
          86     DGP         Dissimilar Gateway Protocol      [74,ML109]
          87     TCF         TCF                                  [GAL5]
          88     IGRP        IGRP                               [18,GXS]
          89     OSPFIGP     OSPFIGP                           [83,JTM4]
          90     Sprite-RPC  Sprite RPC Protocol               [143,BXW]
          91     LARP        Locus Address Resolution Protocol     [BXH]
          92     MTP         Multicast Transport Protocol          [SXA]
          93     AX.25       AX.25 Frames                         [BK29]
          94     IPIP        IP-within-IP Encapsulation Protocol  [JXI1]
          95     MICP        Mobile Internetworking Control Pro.  [JXI1]
          96     AES-SP3-D   AES Security Protocol 3-D             [HXH]
          97     ETHERIP     Ethernet-within-IP Encapsulation     [RXH1]
          98     ENCAP       Encapsulation Header             [148,RXB3]
       99-254                Unassigned                            [JBP]
          255                Reserved                              [JBP]
*}



{
ARP = ADRESS Resolution Protokoll:

Beispiel 1:
 1  2  3  4  5  6  7  8    9 10 11 12 13 14 15 16 17 18 19 20 21 22
00 03 00 cc 07 04 00 01   88 8c 6a 96 9e 40 60 2c 82 20 0A 00 00 00 00 00
                          88 8e 72 8a a0 40 60 2c 82 13 32
 AX25  Prot.!   ! REQUEST  D F  5   K  O       44 130 32 10
        lenAX25 ip-Len                           ProtAddr

Byte     bedeutung

01,02    int16 hardware;                 /* Hardware type */  ( MSB,LSB ! )
03,04    int16 protocol;                 /* Protocol type */
05       char hwalen;                    /* Hardware address length, bytes */
06       char pralen;                    /* Length of protocol address */
07,08    int16 opcode;                   /* ARP opcode (request/reply) */
9-       uchar shwaddr[hwalen];          /* Sender hardware address field */
[4]      int32 sprotaddr;                /* Sender Protocol address field */
         char thwaddr[hwalen]            /* Target hardware address field */
[4]      int32 tprotaddr;                /* Target protocol address field */

/* ARP opcodes */
        ARP_REQUEST     1
        ARP_REPLY       2

/* Hardware types */
        ARP_NETROM     = 0       /* Fake for NET/ROM (never actually sent) */
        ARP_ETHER      = 1       /* Assigned to 10 megabit Ethernet */
        ARP_EETHER     = 2       /* Assigned to experimental Ethernet */
        ARP_AX25       = 3       /* Assigned to AX.25 Level 2 */
        ARP_PRONET     = 4       /* Assigned to PROnet token ring */
        ARP_CHAOS      = 5       /* Assigned to Chaosnet */
        ARP_ARCNET     = 7
        ARP_APPLETALK  = 8
}

PROCEDURE ARP2Str ( p1: pointer; len : WORD;  VAR s : String );
  CONST ofsHWALEN = 5; {offset der Hardware-Adressen-Lnge }
    VAR p : ^by1Array;
        Wor,
        hardware : Word;
BEGIN
  globalResultProtocol :=  grp_ARP;
  p := p1; {* Konvertieren *}
  hardware := wordML(p,1);
  s := 'ARP  HW:';
  IF hardware = 3 THEN s:=s+' AX25'
                  ELSE s:=s+f_STR (hardware);
  s := s + ' Prot:' + MLWord2Str (p,3) +'  Opcode:';

  CASE p^[8] OF
     1 : s := s + 'request';
     2 : s := s + 'reply'
    ELSE s := s + MLWord2Str (p,7);
  END;

  IF Hardware = 3 THEN
    BEGIN

    s := s + CRLF + ' [';

    FOR wor := 16 TO 19 DO  s := s + f_str(p^[wor]) + '.';
    Dec ( Byte (s[0]) ); {* Letzten Punkt entfernen *}
    s := s+'], ';
    FOR wor := 9 TO 14 DO   s := s + char ( Byte (p^[wor]) DIV 2);
    s := s + CRLF + ' [';
    FOR wor := 27 TO 30 DO  s := s + f_str(p^[wor]) + '.';
    Dec ( Byte (s[0]) ); {* Letzten Punkt entfernen *}
    s := s+'], ';
    FOR wor := 20 TO 25 DO  s := s + char ( Byte (p^[wor]) DIV 2);
    END;
END; {* arp *}

{-------------------------------------------------------------------------}

PROCEDURE DumpNetRomNodes (VAR hdl:TEXT;  p1 : Pointer; gesamtLen : WORD);
{ *  Format:                                                *
  *       Offset/Elw Lnge                                  *
  *          08 01    7    Call eines Knotens (AX25Call)    *
  *          15 08    6    ID dieses Knotens (ASCII !)      *
  *          21 14    7    via zu diesem Knoten (AX25Call)  *
  *          28 21    1    Qualitt der Verbindung          *}
  VAR TheNetHeader,Ident,ZielCall,ViaCall : STRING;
      i,len,quali      : WORD;
BEGIN
  globalResultProtocol := grp_NODES;
  Flush(hdl);
  SetTextAttr(FARBE_HEADER_NETROM);
  TheNetHeader := 'NODES ';
  FOR i := 1 TO 6 DO
    BEGIN  {* Ident des sendenen Knotens *}
    Addchar(TheNetHeader,char(byte(p1^) {div 2}));
    IncP1(p1);
    END;
  WriteLn(hdl,TheNetHeader);

  len := 7;
  WHILE (len+21 <= gesamtlen)  DO
    BEGIN
    ZielCall:= '';
    AX25Call2String ( p1, ZielCall);
    Ident := '';
    FOR i := 1 TO 6 DO
      BEGIN  {* Ident des sendenen Knotens *}
      Addchar(IDent,char(p1^));
      IncP1(p1);
      END;
    viaCall := ''; AX25Call2String( p1, viaCall);
    quali   := byte(p1^);  IncP1(p1);

    Write (hdl, ' ',Ident+':',
                Str_using (ZielCall,9),
                ' v.'+
                Str_using ( viaCall,7),
                ' >'+
                F_Using(quali,4)+' ' );
    IF (len MOD 2) = 0 THEN WriteLn(hdl);
    Inc (len,21);
    END;
END;


PROCEDURE DumpNetRom (VAR hdl:TEXT;  p1 : Pointer; gesamtLen : longint);
  VAR OpCode         : Byte;
      z_Str          : STRING;
      TheNetHeader   : STRING;
      ptmp,
      pBegin         : POINTER;
      extPid         : WORD;
      sEmpfaenger,
      sAbsender : STRING;
BEGIN
  IF gesamtLen<0 THEN Exit;
  globalResultProtocol := grp_NETROM;
  pBegin := p1;
  IF byte(p1^)=$FF THEN
    BEGIN
    IncP1(p1);
    DumpNetRomNodes(hdl, p1,gesamtLen);
    Exit;
    END;
  IF gesamtlen < 20 THEN Exit; {* Mindestlnge NetRom Header *}

  sAbsender := '';   AX25Call2String ( p1, sAbsender);
  sEmpfaenger :=  '';   AX25Call2String ( p1, sEmpfaenger);
  TheNetHeader :=  'Net/ROM' + sAbsender + '  ' + sEmpfaenger;

  OpCode := ( t1ba(pBegin^)[20] and $0f );
  globalResultProtocol := grp_NETROM+OpCode;
  CASE OpCode of
         0: z_str := 'extPID'; {* beispielsweise zum Transport VON IP-Packets und Fr L3RTT - Messung *}
         1: z_str := 'ConReq' {Connect Request} ;
         2: z_str := 'ConAck' {Connect Acknowledge} ;
         3: z_str := 'DisReq' {Disconnect Request} ;
         4: z_str := 'DisAck' {Disconnect Acknowledge} ;
         5: z_str := 'Info' {Information} ;
         6: z_str := 'InfAck' {Information Acknowledge} ;
        ELSE z_str := ' OPCode: '+F_STR (t1ba(pBegin^)[20]);
      END ;{case}
  TheNetHeader := TheNetHeader + ' <' + z_str + '>' ;

  z_Str := '' ;
  IF ( (t1ba(pBegin^)[20]) and $80 ) <> 0 THEN z_str := ' [Choke]';
  IF ( (t1ba(pBegin^)[20]) and $40 ) <> 0 THEN z_str := ' [NAK]';
  IF ( (t1ba(pBegin^)[20]) and $20 ) <> 0 THEN z_str := ' [More]';

  TheNetHeader := TheNetHeader + ' ' + z_str + '  ttl:' + f_Str (t1ba(pBegin^)[15])  {* LifeTime *};
  IF OpCode = 1 THEN
    BEGIN {* InfoBlock des ConReq auswerten *}
    TheNetHeader := TheNetHeader + CRLF + ' ';
    pTmp := @t1ba(pBegin^)[29];
    AX25Call2String ( pTmp, TheNetHeader);
    TheNetHeader := TheNetHeader + ''  ;
    pTmp := @t1ba(pBegin^)[22];
    AX25Call2String ( pTmp, TheNetHeader);
    {delLen := 20+15 ;}
    END ;
  IF OpCode = 2 THEN;;;; {DelLen := 20+1;  } {ConAck}

  IF (OpCode = 1) OR (OpCode = 2) THEN TheNetHeader := TheNetHeader
                                     + ' L4-Gre:'+ f_Str(t1ba(pBegin^)[21]) + ' ' ;

  IF (OpCode >= 3) AND (OpCode <= 6) OR (OpCode  = 1) THEN
    BEGIN {* opcodes 1,3,4,5,6 *}
    TheNetHeader := TheNetHeader + ' Ind:' + f_Str(t1ba(pBegin^)[16])
                                 + ' ID:'  + f_Str(t1ba(pBegin^)[17]);
    END;

  IF (OpCode = 5) OR (OpCode = 6) THEN
    BEGIN       {* Info *} {* InfoAck *}
    TheNetHeader := TheNetHeader + ' R:'+ f_Str(t1ba(pBegin^)[19]) ;
    IF  OpCode = 5 THEN TheNetHeader := TheNetHeader
                                      + ' S:' + f_Str(t1ba(pBegin^)[18]);

    END;

  Flush(hdl);
  SetTextAttr(FARBE_HEADER_NETROM);
  Write(hdl,TheNetHeader);

  IF (Opcode = 0)
    THEN BEGIN  {* extPid *}
         Writeln(hdl);
         p1 := pBegin;
         IncPn(p1,21);
         extPid := (t1ba(pBegin^)[16] AND $3f);
         {testen:}
         IF extPid = 16
           THEN DumpNetRomNodes(hdl, IncP(p1,1),gesamtLen-20)
           ELSE Dump_AX25 (hdl, extPID, p1, gesamtlen-20 ); {! Rekursion !}
                 {    ELSE Write(hdl,    '  unbekannter ePID?:'
                         + f_Str(t1ba(pBegin^)[16])+'/'
                         + f_Str(t1ba(pBegin^)[17])
                         ); }
         END
    ELSE IF (Opcode=5) AND (sEmpfaenger='L3RTT ') THEN
         BEGIN {* Laufzeitmessung *}
         globalResultProtocol := grp_NETROM_L3RTT;
         Writeln(hdl);
         Write(hdl,'LaufzeitMessung');
         DumpText (hdl, IncP(pBegin,20), gesamtLen-20, false);
         END
    ELSE BEGIN
         IF GesamtLen>20 THEN
           BEGIN
           Writeln(hdl);
           Flush(hdl);
           SetTextAttr (FARBE_OTHER_TEXTDATA);
           DumpText (hdl, IncP(pBegin,20), gesamtLen-20,true);
           END;
         END;
END;


{---------- Broadcast------------------------------------------------------}


{* Kopf in jedem Frame:
    <flags>     1 byte (2 Bits definiert fLength und EOF)
    <file_id>   4-byte
    <file_type> 1-Byte (is the same byte which is found in the file
                        header record in the file)
    <offset>    3 Byte 24 bits
    <data>      (undef)
    <crc>       2 Byte (16-bit CRC XMODEM)
*}



PROCEDURE BCFileHeader2Str ( p1: pointer; len : WORD;  VAR sDat : String );
{* p1 zeigt auf Anfang des FILEheaders, NICHT des FRAMEheaders! *}
  VAR bfh : T_BCFileHeader;
      fVollstaendig : BOOLEAN;
BEGIN
  globalResultProtocol := grp_BCHEAD;
  fVollstaendig := Mem2BCFileHeader ( p1, len, bfh );
  sDat := 'DateiInfo '  {fileheader}
        + 'ID:' + HexLIString(bfh.fid)
        + ' Lnge:' + f_liStr(bfh.bodyOffset)+'/'+f_liStr(bfh.filen)
      { + #13#10}
        + '  ' + bfh.sRubrik+' @ '+bfh.sVerteil
        + '  ' + bfh.sAbsender+'  $'+bfh.sBid
        + #13#10
        + '  "'+ bfh.sTitle+'"';
  IF NOT fVollstaendig THEN sDat := sDat+#13#10+'[Fortsetzung folgt]';
END;


PROCEDURE BC2Str ( p1: pointer; len : WORD;
                   VAR sHead, sDat : String;
                   VAR fPlainSDat:BOOLEAN );
{- Wandelt einen Speicherbereich mit einem Broadcastframe in lesbaren
 - String um.
 - return: fPlainSDat=TRUE -> sDat ist plainText, ansonsten auch lesbar
 -}
  VAR p : ^t_bcFrame;
      crc, {w,}
      i,l: Longint;
      fBlock : BOOLEAN;
{      pDeb : POINTER; }
BEGIN {$R-}
  fPlainSDat := TRUE;
  globalResultProtocol := grp_BC;
  p := p1; {* Konvertieren *}

{  pDeb := IncP(p1,len-5); }

  fBlock := (p^.h.flag AND $02) = 0;

  l := longint(len) - sizeof(T_BCFrameHEADER) - 2 {Frame-crc};
  sHead := 'BC'
         + 'Ver.'     + f_str((p^.h.flag AND $0c) SHR 2)
         + ' Typ:'    + f_str(p^.h.filetyp)
         + ' ID:'     + HexLIString(p^.h.fileid)
         + ' offset:' + f_liStr(longint(p^.h.offset)+65536*p^.h.offsetH)
         + ' Len:'    + f_liStr( l )
       ;
  IF p^.h.flag AND $20 <> 0 THEN sHead := sHead + '  LAST';

{  w :=  Calc_CRCFBB( 0, p1, len-2 ) ; }

  crc := Calc_CRCFBB( 0, p1, len ) ;
  IF Crc<>0 THEN
    BEGIN
    sHead := sHead + #13#10 + ' FEHLER FRAME CRC '+
           HexByteString( p^.data[l+1] ) + HexByteString( p^.data[l+2] ) + ' '+
           HexString(  crc );
    END;
  sDat := '';
  IF longint(p^.h.offset)+65536*p^.h.offsetH = 0
    THEN BEGIN
         BCFileHeader2Str ( @p^.data[1], l, sDat );
         fPlainSDat := FALSE;
         END
    ELSE BEGIN
         FOR i := 1 TO l DO
            sDat := sDat + char(p^.data[i]);
         END;
END; {* bc *}


{}

FUNCTION Pid2String(pid : longint):STRING;
BEGIN
  CASE Pid OF
    PID_Text    : Pid2String:='Text';
    PID_IP      : Pid2String:='IP';
    PID_ARP     : Pid2String:='ARP';
    PID_Segment : Pid2String:='AX-Segm';
    PID_NetRom  : Pid2String:='NetROM';
    PID_FlexNet : Pid2String:='FlexNet';
    PID_BC      : Pid2String:='BC-PacSat';
    ELSE          Pid2String:=' Typ:'+f_listr(pid);
   END;
END;


PROCEDURE Dump_AX25 (VAR hdl:TEXT;  pid : BYTE; p : Pointer; len : WORD);
{* Inhalt eines Ax25-Frames interpretierend auf "Stream" hdl ausgeben *}
  VAR s,s2 : String;
      flag : BOOLEAN;
BEGIN
  CASE Pid OF
    PID_Text   : DumpText(hdl, p, len, true);
    PID_MayBeBC,
    PID_BC     : BEGIN
                 BC2Str (p, len, s, s2, flag);
                 Flush(hdl);
                 SetTextAttr ( FARBE_HEADER_BC );
                 Write(hdl,s);
                 IF not Flag or opt.fShowBCBody THEN
                   BEGIN
                   Flush(hdl);
                   IF flag THEN SetTextAttr ( FARBE_OTHER_TEXTDATA );
                   WriteLn(hdl);
                   DumpText(hdl, @s2[1], length(s2),true);
                   END;
                 END;
    PID_IP     : DumpIP (hdl, p, len);
    PID_FlexNet: DumpText(hdl, p, len,false);
    PID_NetROM : DumpNetROM (hdl, p, len);
    PID_Segment: DumpPIDSegment (hdl, p, len);
    PID_ARP    : BEGIN
                 ARP2Str    (p, len,s);
                 Flush(hdl);
                 SetTextAttr ( FARBE_HEADER_ARP );
                 Write(hdl,s);
                 END;
      ELSE{case} BEGIN
                 DumpText (hdl, p, len,false);
                 END;
   END; {* CASE *}
END;


END.
