{- Dieser Quellfile gehrt zu DG9EPs Lauscher-Projekt, Verwendung nur unter
 - Bercksichtigung des beiliegenden licence.txt.   (C)1989-1996, DG9EP
 -}
Program MonitorDOSKiss;
{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X-,Y+}
{$M 16384,0,655360}
{$IFDEF os2} Nix. Keine OS/2 Version {$ENDIF}

USES Crt,dump,monitor,fd_div,toolmoni,mo_def;

CONST  fRR : BOOLEAN = false;

  CONST OFS_LCR = 3; {* LineControlRegister *}
        OFS_MCR = 4; {* ModemControlRegister *}
        OFS_LSR = 5; {* LineStatusRegister *}
        OFS_MSR = 6;
        OFS_IIR = 2; (* Interrupt Kennungsregister *)
        OFS_IER = 1; (* Interrupt Freigaberegister *)

  TYPE  T_Parit = (even,odd,no);

PROCEDURE InitPC_UART ( bport : INTEGER;	baud : REAL;
   		     databit,stopbit : Byte; parit : T_Parit  );
  VAR divisor : INTEGER;
      local   : Byte;
    {$IFDEF Doku_16550}
    IIR:   Lesen:                           Schreiben:
    Bit 0   Interupt Pending                FIFO enable
        1   ID-Bit 1                        FIFO Reset receive
        2   ID-Bit 2                        FIFO Reset transmit
        3   ID-Bit 3 (FIFo-Timeout          0
            (immer nach 4 Zeichen)          0
        4   0                               0
        5   0                               0
        6   FIFO ist AN (nur 16550A ff)     TriggerLevel 0
        7   FIFO ist AN                     TriggerLevel 1
    tl1 und tl0: 0=1Byte, 1=4Byte, 2 = 8Byte, 3=14 Byte
    {$ENDIF}
BEGIN
  Divisor :=  ROUND (115200.0 / Baud );
  Port [bport+3] := $80;  {* LineCtrl : Bit7= 1 --> Umschaltung auf Baudratenregister *}
  Port [bport  ] := Lo (divisor);
  Port [bport+1] := Hi (divisor); {* BaudRate einstellen *}

  CASE databit OF
       8 : local := 3 ; { 11 }
       7 : local := 2 ; { 10 }
       6 : local := 1 ; { 01 }
      ELSE local := 0 ; { 00 }
    END ;

  IF stopbit = 2 THEN ORself(local,4); {* Bit 2 *}

  CASE parit OF
	  even : ORself(local,$18); {*  Bit 4 setzen, Bit 3 setzen  *}
	  odd  : ORself(local,$08); {*  Bit 4 nicht setzen, Bit 3 setzen  *}
	  ELSE     		  ; {*  Bit 4 nicht setzen, Bit 3 nicht setzen  *}
	  END;
  port [bport+OFS_LCR] := local ;

  {* zunchst das LSR nochmals lesen: angeblich blockiert der     *}
  {* UART, wenn das Overrunbit noch gesetzt ist:  (DL5FBD, 11/90) *}
  IF port [bport+OFS_LSR] = 0 THEN;

  port [bport+OFS_IER] := 0; (* kein Interrupt *)
  port [bport+4] := $0b;  {* 000 0 10 11  dtr/rts setzten *}
                          {* ......^ BIT 3 sollte immer gesetzt sein; bei manchen Rechnern ist das die Interruptfreigabe *}
  IF port [BPort]=0 THEN; {*  RX Port nochmals leerlesen *}

  {* 16550A FIFO an - auf Verdacht, 8 Byte Trigger; alles Reseten. s. ct 2/92 s.190 *}
  port [BPort+OFS_IIR] := $81;
  local := port [BPort+OFS_IIR] AND $C0;

  Write (' SIO-Typ ');
  IF      local = $80 THEN WriteLn ('16550 - Ein FIFO, der NICHT richtig funktioniert')
  ELSE IF local = $C0 THEN Writeln ('16550A - Der FIFO, der funktioniert')
  ELSE                     Writeln ('8250 - kein FIFO, Abt.Alt aber bezahlt');
END;


PROCEDURE SendChar (c : Char; baseIO : WORD);
BEGIN
  WHILE (port[BaseIO+OFS_LSR] AND $20 = 0) DO;  {* waiting for a free 8250 *}
  Port [BaseIO] := Byte (c);
END;


PROCEDURE Main;
  LABEL l_eowhile;
  VAR i : WORD;
      ch : CHAR;
      kissbuf,
      aDaten : T_aDaten;
      nDaten : LongInt;
      nPort,
      baseIO,
      lenkiss      : Word;
      escstate     : Byte;
      s,sTmp,
      sHeader : STRING;
      strucHeader : t_hheader;
      nBaudrate : LongInt;
      fEnde : BOOLEAN;

BEGIN
  nPort := 2;
  nBaudrate := 4800;
  baseIO:=0;
  FOR i := 1 TO ParamCount DO
    BEGIN
    sTmp := f_Upper(ParamStr(i));
    IF      Copy(sTmp,1,2)='-C' THEN nPort:=f_Val    ( Copy( f_Upper(ParamStr(i)) ,3,255) )
    ELSE IF Copy(sTmp,1,2)='-B' THEN nBaudrate:=f_val( Copy( f_Upper(ParamStr(i)) ,3,255) )
    ELSE IF Copy(sTmp,1,2)='-P' THEN baseio:=f_val( Copy( f_Upper(ParamStr(i)) ,3,255) );
    END;
  IF baseIo=0 THEN
    BEGIN
    IF nPort=1 THEN baseio := $3f8;
    IF nPort=2 THEN baseio := $2f8;
    IF nPort=3 THEN baseio := $3e8;
    IF nPort=4 THEN baseio := $2e8;
    END;
  WriteLn(' Benutzt: Schnittstelle Com',nPort,': mit ',nBaudrate,' Baud, N,8,1');
  WriteLn(' Aufruf: MoniDKis -C',nPort,' -B',nBaudrate,' -P$',HexString(baseio));

  InitPC_UART ( baseio, nBaudRate, 8, 1, no );

  escstate := 0;
  sHeader := ''; lenKiss := 0;
  s := ^x+^x+#27+'@K1'+#$0d+#$0d;
  FOR i := 1 TO length(s) do SendChar(s[i],baseIo);
  FOR i := 1 TO length(s) do SendChar(s[i],baseIo);

  s := char(FEND)+#$80+char(FEND);  {SMACK locken...}
  FOR i := 1 TO length(s) do SendChar(s[i],baseIo);
  FOR i := 1 TO length(s) do SendChar(s[i],baseIo);

  REPEAT
    fEnde := FALSE;
    WHILE (Port[BaseIO+OFS_LSR] AND 1) <> 1 DO
      BEGIN
      IF keyPressed THEN IF DoReadKey(ReadKey) THEN goto l_eowhile;
      END;
    ch := char(port[BaseIO]);
    IF ch <> char(FEND)
      THEN BEGIN
           IF ch=char(fEsc)
             THEN escstate := fesc
             ELSE IF Escstate=fesc THEN
                    BEGIN
		    Inc(lenKiss);
		    IF      ch=char(tfEnd) THEN kissBuf[lenKiss] := char(fend)
		    ELSE IF ch=char(tfEsc) THEN kissBuf[lenKiss] := char(fesc);
		    escstate := 0;
		    END
	     ELSE BEGIN
		  Inc(lenKiss);
		  kissBuf[lenKiss] := ch;
		  END;
	   END
      ELSE IF lenKiss > 1
	    THEN BEGIN {Frame zu Ende}
		 IF Kiss2Host(@kissbuf[1], lenKiss,  sHeader, aDaten, nDaten)
		   THEN BEGIN {Frame ok }
			IF length(sHeader) < 115
			  THEN BEGIN
			       Auswerten( output, sHeader, aDaten, nDaten, strucHeader)
			       END
			  ELSE BEGIN
			       IF fRR THEN BEGIN
					   SetTextAttr(_white_cyan);
					   WriteLn(sHeader);
					   END;
                               END;
                        END
		   ELSE BEGIN
			IF kissbuf[1] = 'E'
			  THEN BEGIN
			       sHeader := '';
			       ReplayWriteBuffer(sHeader,@kissbuf[1], lenKiss);
			       DumpIP (output,@kissbuf[1], lenKiss);
			       lenKiss := 0;
			       END
			  ELSE BEGIN
			       SetTextAttr(FARBE_FEHLER);
			       WriteLn('[fehlerhaft] ',sHeader);
			       END;
			END;
		 lenKiss := 0;
		 END
	    ELSE BEGIN
		 END;
   fEnde := FALSE;
   IF keyPressed THEN IF DoReadKey(ReadKey) THEN fEnde := TRUE;
 UNTIL fEnde;
 l_eowhile:
END;

BEGIN
  SetVersion('Moni/Dos/KISS','9.11.96');
  Replay(cAll,'MoniDKis.rpl');
  PostInit;
  WriteStatus;
  Main;
END.
